LibApp/LibApp/urls.py
from django.contrib import admin
from django.urls import path, include
from app import views
from django.views.generic import TemplateView

urlpatterns = [
    path('', TemplateView.as_view(template_name='app/index.html')),
    path('admin/', admin.site.urls),
    path('app/',include('app.urls'),name="app"),
    path('accounts/', include('allauth.urls')),
    path('logout/',views.user_logout, name="logout"),
]

LibApp/app/urls.py
from django.urls import path
from app import views

app_name="app"
urlpatterns=[
    path('user_login/',views.user_login,name="user_login"),
    path('register/',views.register,name="register"),
    path('preference/', views.preference,name="preference"),
    path('dashboard/', views.dashboard, name="dashboard"),
    path('sites/',views.sites, name="sites"),
]

LibApp/app/models.py
from django.db import models

# Create your models here.

LibApp/app/forms.py
from django import forms
from django.contrib.auth.models import User

class userForm(forms.ModelForm):
    password=forms.CharField(widget=forms.PasswordInput)
    confirm_password=forms.CharField(widget=forms.PasswordInput)
    class Meta():
        model=User
        fields=('username', 'email', 'password')

    def clean(self):
        all_clean_data=super().clean()
        password=all_clean_data['password']
        confirm_password=all_clean_data['confirm_password']

        if password!=confirm_password:
            raise forms.ValidationError("Password Not Matching: Re-enter same password!")

LibApp/app/views.py
from django.shortcuts import render
from app.forms import userForm
# Create your views here.

#login modules

from django.contrib.auth import authenticate, login, logout
from django.http import HttpResponse, HttpResponseRedirect
from django.urls import reverse
from django.contrib.auth.decorators import login_required

def index(request):
    return render(request,"app/index.html")

def user_login(request):
    if request.method=="POST":
        username=request.POST.get('username')
        password=request.POST.get('password')

        user=authenticate(username=username, password=password)

        if user:
            if user.is_active:
                login(request, user)
                return render(request, "app/login.html")

            else:
                return HttpResponse("ACCOUNT NOT ACTIVE")

        else:
            print("Someone tried to login but failed:")
            print(f"Username: {username}\nPassword: {password}")
            return HttpResponse("</h1> INVALID LOGIN DETAILS: LOGIN AGAIN </h1>")
    else:
        return render(request, "app/login.html")

@login_required()
def user_logout(request):
    logout(request)
    return render(request, "app/index.html")

def register(request):
    registered=False

    if request.method=="POST":
        user_form=userForm(data=request.POST)

        if user_form.is_valid():

            user=user_form.save()
            user.set_password(user.password)
            user.save()

            registered=True
        else:
            print(user_form.errors)
    else:
        user_form=userForm()
    return render(request, "app/register.html", context={"user_form":user_form, "registered":registered})

def preference(request):    
    return render(request, "app/preference.html")

def dashboard(request):
    return render(request, "app/dashboard.html")


def sites(request):
    return render(request, 'app/sites.html')

LibApp/templates/app/dashboard.html
<!DOCTYPE html>
{% load static %}
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
  <title>DASHBOARD</title>
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link rel="icon" href="{% static 'images/books.png' %}" type="image/x-icon">
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css" integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk" crossorigin="anonymous">
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI" crossorigin="anonymous"></script>
<link rel="stylesheet" href="{% static 'css/dashboard.css' %}">
<link href="https://fonts.googleapis.com/css2?family=Noto+Sans&display=swap" rel="stylesheet">
  </head>
  <body background="{% static 'images/bg.png' %}">
    {% if user.is_authenticated %}
    <div id="anc"><a href="{% url 'logout' %}"> <img src="{% static 'images/logout.svg' %}" alt="logout" height="40"></a></div>
   <p class="db">DASHBOARD</p>

<div class="container">
<div class="whole">
  
    <div class="container">
    <div class="row">
    <!-- <div class="box-wrap"> -->
      <div class="element col-lg-3 col-md-3 col-6">
        <center> <a href="#"> <p> <img src="{% static 'images/book.svg' %}" alt="" height="100"></p> BOOKS </a></center>
      </div>
      <div class="element col-lg-3 col-md-3 col-6">
      <center> <a href="{% url 'app:sites' %}"> <p><img src="{% static 'images/web.svg' %}" alt="broken link" height="100"></p>SITES</a></center>
      </div>
      <div class="element col-lg-3 col-md-3 col-12">
      <center> <a href="#"> <p><img src="{% static 'images/document.svg' %}" alt="broken_link" height="100"></p>SYLLABUS</a></center>
      </div>
    </div>
    </div>
  <!-- </div> -->

    <div class="container">
    <div class="row">
    <!-- <div class="box-wrap"> -->
      <div class="element col-lg-3 col-md-3 col-6">
      <center>  <a href="http://makautexam.net/" target="_blank"> <p><img src="{% static 'images/makaut.png' %}" alt="broken_link" height="100"></p>MAKAUT</a> </center>
      </div>
      <div class="element col-lg-3 col-md-3 col-6">
      <center> <a href="#"> <p><img src="{% static 'images/news-paper.svg' %}" alt="broken_link" height="100"></p>NEWS</a></center>
      </div>
      <div class="element col-lg-3 col-md-3 col-12">
      <center> <a href="#"> <p><img src="{% static 'images/quiz.svg' %}" alt="broken_link" height="100"></p>QUIZ</a></center>
      </div>
    </div>
    </div>
  </div>
</div>

    {% else %}
    <div class=" cj container jumbotron">
    <h1>You need to login to view this page, Redirecting to login</h1>
    <meta http-equiv="refresh" content="2; URL={% url 'app:user_login' %}" />
  </div>
    {% endif %}
  </body>
</html>

LibApp/templates/app/index.html
<!DOCTYPE html>
{% load static %}
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
    <title>WELCOME!</title>
    <link rel="icon" href="{% static 'images/books.png' %}" type="image/x-icon">
    <link href="https://fonts.googleapis.com/css2?family=Noto+Sans&display=swap" rel="stylesheet">
    <link rel="stylesheet" href="{% static 'css/index.css' %}">
  </head>
  <body background="{% static 'images/bg.png' %}">
      <div class="textData">
      <p> <div class="wc">
        WELCOME
      </div>
    <div class="to">
      to
    </div>
  <div class="ml">
    MY LIBRARY
  </div> </p>
      </div>
      <div class="logo">
        <center><img src='{% static "images/books.png" %}' alt="broken link" height="150" width="150"></center>
      </div>
    <center>  <p class="para">My Library can help students learn more through digital book and to excel in their studies</p></center>
  <center>  <button onclick="location.href = '{% url 'app:user_login' %}';" type="button" name="button">GET STARTED</button></center>
  </body>
</html>

LibApp/templates/app/login.html
<!DOCTYPE html>
{% load static %}
{% load socialaccount %}
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
  <title>Login</title>
  <link rel="icon" href="{% static 'images/books.png' %}" type="image/x-icon">
  <link rel="stylesheet" href="{% static 'css/login.css' %}">
  <link href="https://fonts.googleapis.com/css2?family=Noto+Sans&display=swap" rel="stylesheet">
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css" integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk" crossorigin="anonymous">
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI" crossorigin="anonymous"></script>
  </head>
  <body background="{% static 'images/bg.png' %}">
    {% if user.is_authenticated %}
    <div class="container jumbotron cj">
    <h1>Welcome {{ user.username }} </h1>
    <meta http-equiv="refresh" content="0.5; URL={% url 'app:preference' %}" />
  </div>
    {% else %}
    <center>
    <p class="logo"><img src="{% static 'images/books.png' %}" alt="Broken Link" height="150" width="150"></p>
    <p class="ml">MY LIBRARY</p>
    <div class="formbg">
      <p id="login">LOGIN</p>
      <form class="frm" action="{% url 'app:user_login' %}" method="post">
        {% csrf_token %}
        <input class="fields" type="text" name="username" placeholder="Username"> <br><br>
        <input class="fields" type="password" name="password" placeholder="Password"><br><br>
        <button id="loginbtn" type="submit" name="button">LOGIN</button><br>
      </form>
      OR <br>
      <div onclick="location.href = '{% provider_login_url 'google' %}';" class='g-sign-in-button'>
  <div class=content-wrapper>
      <div class='logo-wrapper'>
          <img src='{% static "images/google.png" %}'>
      </div>
      <span class='text-container'>
    <span>Sign in with Google</span>
  </span>
  </div>
</div><br>
Don't have account? <br>
<a id="register" href="{% url 'app:register' %}">Register</a>
</div>
  </center>
  {% endif %}
  </body>
</html>

LibApp/templates/app/preference.html
<!DOCTYPE html>
{% load static %}
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
    <title>Preference page</title>
    <link rel="icon" href="{% static 'images/books.png' %}" type="image/x-icon">
    <link rel="stylesheet" href="{% static 'css/preference.css' %}">
      <link href="https://fonts.googleapis.com/css2?family=Noto+Sans&display=swap" rel="stylesheet">
      <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css" integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk" crossorigin="anonymous">
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI" crossorigin="anonymous"></script>
    <script type="text/javascript">
    function populate(s1, s2)
    {
      var s1=document.getElementById('course');
      var s2=document.getElementById('sem');
      s2.innerHTML="";
      if(s1.value == 'BBA' || s1.value== "BCA" || s1.value== "MCA")
      var optionArray=[ "1|1st", "2|2nd", "3|3rd", "4|4th", "5|5th", "6|6th"]
      else if(s1.value=="MTECH_EE" || s1.value=="MTECT_ECE")
      var optionArray=["1|1st", "2|2nd", "3|3rd", "4|4th"]
      else if(s1.value=="pleaseSelect")
      var optionArray=["pleaseSelect|Please select course first"]
      else
      var optionArray=["1|1st", "2|2nd", "3|3rd", "4|4th", "5|5th", "6|6th", "7|7th", "8|8th"]

      for(options in optionArray)
      {
        var pair=optionArray[options].split("|");
        var newOption=document.createElement("option")
        newOption.value=pair[0]
        newOption.innerHTML=pair[1]
        s2.options.add(newOption)
      }
    }
    </script>
  </head>
  <body background="{% static 'images/bg.png' %}">
    {% if user.is_authenticated %}
        <div id="anc"><a href="{% url 'logout' %}"> <img src="{% static 'images/logout.svg' %}" alt="logout" height="40"></a></div>
    <center>
      <p class="logo"><img src="{% static 'images/books.png' %}" alt="Broken Link" height="150" width="150"></p> <br>
  <p class="ml">MY LIBRARY</p>
    <div class="formbg">

      <form class="frm" action="{% url 'app:dashboard' %}" method="POST">
          {% csrf_token %}
        <select class="fields btn btn-lg btn-link dropdown-toggle dropdown-toggle-split" id="course" onchange="populate('course', 'sem')">
        <option selected value="pleaseSelect">Please Select</option>
        <option value="BBA">BBA</option>
        <option value="BCA">BCA</option>
        <option value="CIVIL">CIVIL</option>
        <option value="CSE">CSE</option>
        <option value="ECE">ECE</option>
        <option value="EE">EE</option>
        <option value="IT">IT</option>
        <option value="ME">ME</option>
        <option value="MCA">MCA</option>
        <option value="MTECT_ECE">MTECH_ECE</option>
        <option value="MTECH_EE">MTECH_EE</option>
      </select>
      <br><br>
      <select class="fields fields btn btn-lg btn-link dropdown-toggle dropdown-toggle-split" id='sem'>
        <option selected>Please select course first</option>
      </select>
      <br><br>
      <input id="nextBtn" type="submit" name="" value="Next">
    </form>
  </div>
         <br> <br>
       </center>
       {% else %}
       <div class="container jumbotron cj">
       <h1>You need to login to view this page, Redirecting to login</h1>
       <meta http-equiv="refresh" content="2; URL={% url 'app:user_login' %}" />
     </div>
       {% endif %}
  </body>
</html>

LibApp/templates/app/register.html
<!DOCTYPE html>
{% load static %}
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
  <title>Register</title>
  <link rel="icon" href="{% static 'images/books.png' %}" type="image/x-icon">
  <link href="https://fonts.googleapis.com/css2?family=Noto+Sans&display=swap" rel="stylesheet">
  <link rel="stylesheet" href="{% static 'css/register.css' %}">
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css" integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk" crossorigin="anonymous">
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI" crossorigin="anonymous"></script>
<script>

function goBack() {

  window.history.back();

  }

</script>
  </head>
  <body background="{% static 'images/bg.png' %}">
    {% if registered %}
    <div class="container jumbotron cj">
    <h1>Thank you for registering redirecting to LOGIN!</h1>
    <meta http-equiv="refresh" content="2; URL={% url 'app:user_login' %}" />
  </div>
    {% else %}
  <center>
  <p class="logo"><img src="{% static 'images/books.png' %}" alt="Broken Link" height="150" width="150"></p>
  <p class="ml">MY LIBRARY</p>
  <div class="formbg">
  <p id="register">REGISTER</p>
    <form class="frm" enctype="multipart/form-data" method="post">
      {% csrf_token %}
      {{ user_form.as_p }}
    <input id="regbtn" type="submit" name="" value="Register">
    </form>
    <p>Already have an account?</p>
    <button class="login btn btn-link" onclick="goBack()">Login</button>
</div>
</center>
{% endif %}
</body>
</html>

LibApp/templates/app/sites.html
<!DOCTYPE html>
{% load static %}
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
    <title>SITES</title>
    <link rel="icon" href="{% static 'images/books.png' %}" type="image/x-icon">
    <link rel="stylesheet" href="{% static 'css/sites.css' %}">
      <link href="https://fonts.googleapis.com/css2?family=Noto+Sans&display=swap" rel="stylesheet">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css" integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk" crossorigin="anonymous">
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI" crossorigin="anonymous"></script>
  </head>
  <body background="{% static 'images/bg.png' %}">
    {% if user.is_authenticated %}
    <div id="anc"><a href='{% url "logout" %}'> <img src="{% static 'images/logout.svg' %}" alt="logout" height="40"></a></div>
    <div class="container">
      <p style="padding-top:20px;" class="site">SITE</p> <br>
          <div class="row scrollView">
            <div class="col-11 m-3" onclick="window.open('https://www.hackerrank.com','_blank')">
          <img src="https://img.icons8.com/windows/96/000000/hackerrank.png" align="left" height="50"/>Hackerrank
          </div>
            <div class="col-11 m-3" onclick="window.open('https://www.codechef.com','_blank')">
             <img src="{% static 'images/codechef.svg' %}" alt="broken_link" align="left" height="50"> CodeChef
            </div>
            <div class="col-11 m-3" onclick="window.open('https://www.tutorialspoint.com/index.htm','_blank')">
              <img src="https://yt3.ggpht.com/a/AATXAJzvcPnvbl_ujFvCTNsTlxN93Y3VNzOPwgTpY6OF=s900-c-k-c0x00ffffff-no-rj" alt="broken_link" height="50" align="left"> Tutorialspoint</a>
            </div>
            <div class="col-11 m-3" onclick="window.open('https://www.geeksforgeeks.org/','_blank')">
              <img src="{% static 'images/gfg.svg' %}" alt="broken_link" align="left" >
                Geek For Geeks</a>
            </div>
            <div class="col-11 m-3" onclick="window.open('https://www.linkedin.com','_blank')">
              <img src="{% static 'images/linkedin.svg' %}" alt="broken_link" height="50" align="left">LinkedIn
            </div>
            <div class="col-11 m-3" onclick="window.open('https://www.naukri.com/','_blank')">
              <img src="{% static 'images/naukri.png' %}" alt="broken_link" align="left" height="50"> Naukri.com
            </div>
            <div class="col-11 m-3" onclick="window.open('https://www.udemy.com','_blank')">
              <img src="{% static 'images/udemy.svg' %}" alt="broken_link" height="50" align="left" > Udemy
            </div>
            <div class="col-11 m-3" onclick="window.open('https://www.codeforlife.education/','_blank')">
              <img src="https://www.codeforlife.education/static/portal/img/logo_c4l_hexa.png" alt="broken_link" height="50" align="left"> CodeForLife
            </div>
            <div class="col-11 m-3" onclick="window.open('https://academicearth.org/','_blank')">
              <img src="https://images.g2crowd.com/uploads/product/image/large_detail/large_detail_ef94478f6d6832517c2fae3f25162b2e/academic-earth.png" alt="broken_link" height="50" align="left"> Academic Earth
            </div>
            <div class="col-11 m-3" onclick="window.open('https://www.khanacademy.org/','_blank')">
              <img src="https://s.gravatar.com/avatar/5b175ab3090385b31cc5f04ef08f0fc3?size=496&default=retro" alt="broken_link" height="50" target="_blank" align="left">Khan Academy
            </div>
            <div class="col-11 m-3" onclick="window.open('https://www.bitdegree.org/','_blank')">
              <img src="https://s3.us-east-2.amazonaws.com/nomics-api/static/images/currencies/bdg.svg" alt="broken_link" height="50" align="left">Bit Degree
            </div>
            <div class="col-11 m-3" onclick="window.open('https://www.codecademy.com/','_blank')">
              <img src="https://iconape.com/wp-content/files/fi/343970/png/codecademy-logo.png" alt="broken_link" height="50" align="left">CodecAdemy
            </div>
            <div class="col-11 m-3" onclick="window.open('https://www.interviewbit.com/','_blank')">
              <img src="https://i0.wp.com/blog.interviewbit.com/wp-content/uploads/2017/11/cropped-logo-transparent4.png?ssl=1" alt="broken_link" height="50" align="left">InterviewBit
            </div>
            <div class="col-11 m-3" onclick="window.open('https://leetcode.com/','_blank')">
              <img src="https://assets.leetcode.com/static_assets/public/images/LeetCode_logo.png" alt="broken_link" height="50" align="left">LeetCode
            </div>
          </div>
    </div>
    {% else %}
    <div class="container jumbotron cj">
    <h1>You need to login to view this page, Redirecting to login</h1>
    <meta http-equiv="refresh" content="2; URL={% url 'app:user_login' %}" />
  </div>
    {% endif %}
  </body>
</html>